---
title: "Mark a gradebook column with this rubric or marking guide"
description: "An assignment's column is chosen by the assignment's own settings and is refused here.\n\n### Quire permissions\n\nRequired capability: `grade/managegradingforms`.\n\nCredential scopes: `grades:write`.\n\nThe acting subject must also be allowed to perform this action in the organisation."
image: "https://docs.quirelms.com/og.png"
---

> Documentation Index
> Fetch the complete documentation index at: https://docs.quirelms.com/llms.txt
> Use this file to discover all available pages before exploring further.

Path: Quire API › grades

`POST /rubrics/{id}/actions/attach`

An assignment's column is chosen by the assignment's own settings and is refused here.

\### Quire permissions

Required capability: `grade/managegradingforms`.

Credential scopes: `grades:write`.

The acting subject must also be allowed to perform this action in the organisation.

## Authentication

Requires one of the following:

- `apiKey`, http, header `Authorization`, scopes: `grades:write`
- `oauth2`, oauth2, scopes: `grades:write`

## Path parameters

- `attachRubric.path.id` (string, required)

## Header parameters

- `attachRubric.header.Quire-Version` (string, optional) — The dated API revision to serve this request at. Omitted, the request is served at the revision the credential was issued against. The response echoes the revision actually applied.
  - format `date`
- `attachRubric.header.Idempotency-Key` (string, optional) — A caller-chosen key making this request safe to retry. A replay of a completed request returns the recorded response with `Idempotency-Replayed: true`. Reusing a key for a different request is refused.
  - maxLength 255

## Request body

_Required._

- `attachRubric.item_id` (string, required) — A gradebook column in the same course, or in any course for a shared template.
  - format `uuid`; pattern `^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|ffffffff-ffff-ffff-ffff-ffffffffffff)$`

## Example request

```json
{
  "item_id": "4d8cd62e-a579-4dae-af8c-3172f96f8f7c"
}
```

## Code samples

### cURL

```curl
curl --request POST \
  --url https://your-organisation.quirelms.com/api/v1/rubrics/string/actions/attach \
  --header 'Authorization: Bearer <token>' \
  --header 'Content-Type: application/json' \
  --data '
{
  "item_id": "4d8cd62e-a579-4dae-af8c-3172f96f8f7c"
}
'
```

### TypeScript

```typescript
const url = 'https://your-organisation.quirelms.com/api/v1/rubrics/string/actions/attach';
const options = {
  method: 'POST',
  headers: {'Content-Type': 'application/json', Authorization: 'Bearer <token>'},
  body: JSON.stringify({item_id: '4d8cd62e-a579-4dae-af8c-3172f96f8f7c'})
};

fetch(url, options)
  .then(res => res.json())
  .then(json => console.log(json))
  .catch(err => console.error(err));
```

### Python

```python
import requests

url = "https://your-organisation.quirelms.com/api/v1/rubrics/string/actions/attach"

payload = { "item_id": "4d8cd62e-a579-4dae-af8c-3172f96f8f7c" }
headers = {
    "Content-Type": "application/json",
    "Authorization": "Bearer <token>"
}

response = requests.post(url, json=payload, headers=headers)

print(response.text)
```

## Responses

### 200

Success.

#### Example

```json
{
  "id": "string",
  "external_id": "string",
  "course_id": "string",
  "method": "rubric",
  "name": "string",
  "description": "string",
  "options": null,
  "is_template": true,
  "criteria": null,
  "deleted_at": "string",
  "created_at": "string",
  "updated_at": "string"
}
```

- `attachRubric.response.200.id` (string, required)
- `attachRubric.response.200.external_id` (string | null, required)
- `attachRubric.response.200.course_id` (string, required)
- `attachRubric.response.200.method` (string, required)
  - one of `"rubric"`, `"guide"`
- `attachRubric.response.200.name` (string, required)
- `attachRubric.response.200.description` (string | null, required)
- `attachRubric.response.200.options` (unknown, required)
- `attachRubric.response.200.is_template` (boolean, required)
- `attachRubric.response.200.criteria` (unknown, required)
- `attachRubric.response.200.deleted_at` (any of, required)
  - any of: `string`, `null`
- `attachRubric.response.200.created_at` (string, required) — RFC 3339 timestamp in UTC.
- `attachRubric.response.200.updated_at` (string, required) — RFC 3339 timestamp in UTC.

### 401

The credential is missing, malformed, expired or revoked.

#### Example

```json
{
  "type": "http://example.com",
  "title": "string",
  "status": 0,
  "code": "string",
  "category": "validation",
  "detail": "string",
  "request_id": "string",
  "errors": [
    {
      "path": "string",
      "code": "string",
      "detail": "string"
    }
  ],
  "retry_after": 0,
  "docs_url": "http://example.com"
}
```

- `attachRubric.response.401.type` (string, required)
  - format `uri`
- `attachRubric.response.401.title` (string, required)
- `attachRubric.response.401.status` (integer, required)
- `attachRubric.response.401.code` (string, required)
- `attachRubric.response.401.category` (string, required)
  - one of `"validation"`, `"authentication"`, `"authorization"`, `"not_found"`, `"conflict"`, `"precondition"`, `"quota"`, `"rate_limit"`, `"upstream"`, `"internal"`
- `attachRubric.response.401.detail` (string, required)
- `attachRubric.response.401.request_id` (string, required)
- `attachRubric.response.401.docs_url` (string, required)
  - format `uri`
- `attachRubric.response.401.errors` (array<object>, optional)
  - `attachRubric.response.401.errors.path` (string, required) — RFC 6901 JSON Pointer into the request body.
  - `attachRubric.response.401.errors.code` (string, required)
  - `attachRubric.response.401.errors.detail` (string, required)
- `attachRubric.response.401.retry_after` (integer | null, optional)

### 403

The credential lacks the scope this operation requires, or the acting subject lacks the capability.

#### Example

```json
{
  "type": "http://example.com",
  "title": "string",
  "status": 0,
  "code": "string",
  "category": "validation",
  "detail": "string",
  "request_id": "string",
  "errors": [
    {
      "path": "string",
      "code": "string",
      "detail": "string"
    }
  ],
  "retry_after": 0,
  "docs_url": "http://example.com"
}
```

- `attachRubric.response.403.type` (string, required)
  - format `uri`
- `attachRubric.response.403.title` (string, required)
- `attachRubric.response.403.status` (integer, required)
- `attachRubric.response.403.code` (string, required)
- `attachRubric.response.403.category` (string, required)
  - one of `"validation"`, `"authentication"`, `"authorization"`, `"not_found"`, `"conflict"`, `"precondition"`, `"quota"`, `"rate_limit"`, `"upstream"`, `"internal"`
- `attachRubric.response.403.detail` (string, required)
- `attachRubric.response.403.request_id` (string, required)
- `attachRubric.response.403.docs_url` (string, required)
  - format `uri`
- `attachRubric.response.403.errors` (array<object>, optional)
  - `attachRubric.response.403.errors.path` (string, required) — RFC 6901 JSON Pointer into the request body.
  - `attachRubric.response.403.errors.code` (string, required)
  - `attachRubric.response.403.errors.detail` (string, required)
- `attachRubric.response.403.retry_after` (integer | null, optional)

### 404

No such resource, or none this credential is permitted to know about.

#### Example

```json
{
  "type": "http://example.com",
  "title": "string",
  "status": 0,
  "code": "string",
  "category": "validation",
  "detail": "string",
  "request_id": "string",
  "errors": [
    {
      "path": "string",
      "code": "string",
      "detail": "string"
    }
  ],
  "retry_after": 0,
  "docs_url": "http://example.com"
}
```

- `attachRubric.response.404.type` (string, required)
  - format `uri`
- `attachRubric.response.404.title` (string, required)
- `attachRubric.response.404.status` (integer, required)
- `attachRubric.response.404.code` (string, required)
- `attachRubric.response.404.category` (string, required)
  - one of `"validation"`, `"authentication"`, `"authorization"`, `"not_found"`, `"conflict"`, `"precondition"`, `"quota"`, `"rate_limit"`, `"upstream"`, `"internal"`
- `attachRubric.response.404.detail` (string, required)
- `attachRubric.response.404.request_id` (string, required)
- `attachRubric.response.404.docs_url` (string, required)
  - format `uri`
- `attachRubric.response.404.errors` (array<object>, optional)
  - `attachRubric.response.404.errors.path` (string, required) — RFC 6901 JSON Pointer into the request body.
  - `attachRubric.response.404.errors.code` (string, required)
  - `attachRubric.response.404.errors.detail` (string, required)
- `attachRubric.response.404.retry_after` (integer | null, optional)

### 409

The request conflicts with the current state, with a previous use of the same idempotency key, or with a concurrent write.

#### Example

```json
{
  "type": "http://example.com",
  "title": "string",
  "status": 0,
  "code": "string",
  "category": "validation",
  "detail": "string",
  "request_id": "string",
  "errors": [
    {
      "path": "string",
      "code": "string",
      "detail": "string"
    }
  ],
  "retry_after": 0,
  "docs_url": "http://example.com"
}
```

- `attachRubric.response.409.type` (string, required)
  - format `uri`
- `attachRubric.response.409.title` (string, required)
- `attachRubric.response.409.status` (integer, required)
- `attachRubric.response.409.code` (string, required)
- `attachRubric.response.409.category` (string, required)
  - one of `"validation"`, `"authentication"`, `"authorization"`, `"not_found"`, `"conflict"`, `"precondition"`, `"quota"`, `"rate_limit"`, `"upstream"`, `"internal"`
- `attachRubric.response.409.detail` (string, required)
- `attachRubric.response.409.request_id` (string, required)
- `attachRubric.response.409.docs_url` (string, required)
  - format `uri`
- `attachRubric.response.409.errors` (array<object>, optional)
  - `attachRubric.response.409.errors.path` (string, required) — RFC 6901 JSON Pointer into the request body.
  - `attachRubric.response.409.errors.code` (string, required)
  - `attachRubric.response.409.errors.detail` (string, required)
- `attachRubric.response.409.retry_after` (integer | null, optional)

### 422

The request was understood and its content is not valid. `errors` names each field.

#### Example

```json
{
  "type": "http://example.com",
  "title": "string",
  "status": 0,
  "code": "string",
  "category": "validation",
  "detail": "string",
  "request_id": "string",
  "errors": [
    {
      "path": "string",
      "code": "string",
      "detail": "string"
    }
  ],
  "retry_after": 0,
  "docs_url": "http://example.com"
}
```

- `attachRubric.response.422.type` (string, required)
  - format `uri`
- `attachRubric.response.422.title` (string, required)
- `attachRubric.response.422.status` (integer, required)
- `attachRubric.response.422.code` (string, required)
- `attachRubric.response.422.category` (string, required)
  - one of `"validation"`, `"authentication"`, `"authorization"`, `"not_found"`, `"conflict"`, `"precondition"`, `"quota"`, `"rate_limit"`, `"upstream"`, `"internal"`
- `attachRubric.response.422.detail` (string, required)
- `attachRubric.response.422.request_id` (string, required)
- `attachRubric.response.422.docs_url` (string, required)
  - format `uri`
- `attachRubric.response.422.errors` (array<object>, optional)
  - `attachRubric.response.422.errors.path` (string, required) — RFC 6901 JSON Pointer into the request body.
  - `attachRubric.response.422.errors.code` (string, required)
  - `attachRubric.response.422.errors.detail` (string, required)
- `attachRubric.response.422.retry_after` (integer | null, optional)

### 429

A rate limit or a concurrency cap was reached. `Retry-After` says when to try again.

#### Example

```json
{
  "type": "http://example.com",
  "title": "string",
  "status": 0,
  "code": "string",
  "category": "validation",
  "detail": "string",
  "request_id": "string",
  "errors": [
    {
      "path": "string",
      "code": "string",
      "detail": "string"
    }
  ],
  "retry_after": 0,
  "docs_url": "http://example.com"
}
```

- `attachRubric.response.429.type` (string, required)
  - format `uri`
- `attachRubric.response.429.title` (string, required)
- `attachRubric.response.429.status` (integer, required)
- `attachRubric.response.429.code` (string, required)
- `attachRubric.response.429.category` (string, required)
  - one of `"validation"`, `"authentication"`, `"authorization"`, `"not_found"`, `"conflict"`, `"precondition"`, `"quota"`, `"rate_limit"`, `"upstream"`, `"internal"`
- `attachRubric.response.429.detail` (string, required)
- `attachRubric.response.429.request_id` (string, required)
- `attachRubric.response.429.docs_url` (string, required)
  - format `uri`
- `attachRubric.response.429.errors` (array<object>, optional)
  - `attachRubric.response.429.errors.path` (string, required) — RFC 6901 JSON Pointer into the request body.
  - `attachRubric.response.429.errors.code` (string, required)
  - `attachRubric.response.429.errors.detail` (string, required)
- `attachRubric.response.429.retry_after` (integer | null, optional)

### 500

Something failed at our end. Quote `request_id` when reporting it.

#### Example

```json
{
  "type": "http://example.com",
  "title": "string",
  "status": 0,
  "code": "string",
  "category": "validation",
  "detail": "string",
  "request_id": "string",
  "errors": [
    {
      "path": "string",
      "code": "string",
      "detail": "string"
    }
  ],
  "retry_after": 0,
  "docs_url": "http://example.com"
}
```

- `attachRubric.response.500.type` (string, required)
  - format `uri`
- `attachRubric.response.500.title` (string, required)
- `attachRubric.response.500.status` (integer, required)
- `attachRubric.response.500.code` (string, required)
- `attachRubric.response.500.category` (string, required)
  - one of `"validation"`, `"authentication"`, `"authorization"`, `"not_found"`, `"conflict"`, `"precondition"`, `"quota"`, `"rate_limit"`, `"upstream"`, `"internal"`
- `attachRubric.response.500.detail` (string, required)
- `attachRubric.response.500.request_id` (string, required)
- `attachRubric.response.500.docs_url` (string, required)
  - format `uri`
- `attachRubric.response.500.errors` (array<object>, optional)
  - `attachRubric.response.500.errors.path` (string, required) — RFC 6901 JSON Pointer into the request body.
  - `attachRubric.response.500.errors.code` (string, required)
  - `attachRubric.response.500.errors.detail` (string, required)
- `attachRubric.response.500.retry_after` (integer | null, optional)


Source: https://docs.quirelms.com/api/grades/attachRubric/index.md
